.\" mkfs.fat.8 - manpage for fs.fatck
.\"
.\" Copyright (C) 2006-2014 Daniel Baumann <daniel@debian.org>
.\" Copyright (C) 2016 Andreas Bombe <aeb@debian.org>
.\" Copyright (C) 2018-2021 Pali Rohár <pali.rohar@gmail.com>
.\"
.\" This program is free software: you can redistribute it and/or modify
.\" it under the terms of the GNU General Public License as published by
.\" the Free Software Foundation, either version 3 of the License, or
.\" (at your option) any later version.
.\"
.\" This program is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
.\" GNU General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public License
.\" along with this program. If not, see <http://www.gnu.org/licenses/>.
.\"
.\" The complete text of the GNU General Public License
.\" can be found in /usr/share/common-licenses/GPL-3 file.
.\"
.\"
.TH MKFS.FAT 8 @RELEASE_DATE@ "dosfstools @PACKAGE_VERSION@"
.SH NAME
mkfs.fat \- create an MS-DOS FAT filesystem
.\" ----------------------------------------------------------------------------
.SH SYNOPSIS
\fBmkfs.fat\fP [\fIOPTIONS\fP] \fIDEVICE\fP [\fIBLOCK-COUNT\fP]
.\" ----------------------------------------------------------------------------
.SH DESCRIPTION
\fBmkfs.fat\fP is used to create a FAT filesystem on a device or in an image
file.
\fIDEVICE\fP is the special file corresponding to the device (e.g. /dev/sdXX) or
the image file (which does not need to exist when the option \fB-C\fP is given).
\fIBLOCK-COUNT\fP is the number of blocks on the device and size of one block is
always 1024 bytes, independently of the sector size or the cluster size.
Therefore \fIBLOCK-COUNT\fP specifies size of filesystem in KiB unit and not in
the number of sectors (like for all other \fBmkfs.fat\fP options).
If omitted, \fBmkfs.fat\fP automatically chooses a filesystem size to fill the
available space.
.PP
Two different variants of the FAT filesystem are supported.
Standard is the FAT12, FAT16 and FAT32 filesystems as defined by Microsoft and
widely used on hard disks and removable media like USB sticks and SD cards.
The other is the legacy Atari variant used on Atari ST.
.PP
In Atari mode, if not directed otherwise by the user, \fBmkfs.fat\fP will
always use 2 sectors per cluster, since GEMDOS doesn't like other values very
much.
It will also obey the maximum number of sectors GEMDOS can handle.
Larger filesystems are managed by raising the logical sector size.
An Atari-compatible serial number for the filesystem is generated, and a 12 bit
FAT is used only for filesystems that have one of the usual floppy sizes (720k,
1.2M, 1.44M, 2.88M), a 16 bit FAT otherwise.
This can be overridden with the \fB\-F\fP option.
Some PC-specific boot sector fields aren't written, and a boot message (option
\fB\-m\fP) is ignored.
.\" ----------------------------------------------------------------------------
.SH OPTIONS
.IP "\fB\-a\fP" 4
Normally, for any filesystem except very small ones, \fBmkfs.fat\fP will align
all the data structures to cluster size, to make sure that as long as the
partition is properly aligned, so will all the data structures in the
filesystem.
This option disables alignment; this may provide a handful of additional
clusters of storage at the expense of a significant performance degradation on
RAIDs, flash media or large-sector hard disks.
.IP "\fB\-A\fP" 4
Select using the Atari variation of the FAT filesystem if that isn't active
already, otherwise select standard FAT filesystem.
This is selected by default if \fBmkfs.fat\fP is run on 68k Atari Linux.
.IP "\fB\-b\fP \fISECTOR-OF-BACKUP\fP" 4
Selects the location of the backup boot sector for FAT32.
Default depends on number of reserved sectors, but usually is sector 6.
If there is a free space available after the backup boot sector then backup of
the FAT32 info sector is put after the backup boot sector, usually at sector 7.
The backup must be within the range of reserved sectors.
Value 0 completely disables creating of backup boot and info FAT32 sectors.
.IP "\fB\-c" 4
Check the device for bad blocks before creating the filesystem.
.IP "\fB\-C\fP" 4
Create the file given as \fIDEVICE\fP on the command line, and write the
to-be-created filesystem to it.
This can be used to create the new filesystem in a file instead of on a real
device, and to avoid using \fBdd\fP in advance to create a file of appropriate
size.
With this option, the \fIBLOCK-COUNT\fP must be given, because otherwise the
intended size of the filesystem wouldn't be known.
The file created is a sparse file, which actually only contains the meta-data
areas (boot sector, FATs, and root directory).
The data portions won't be stored on the disk, but the file nevertheless will
have the correct size.
The resulting file can be copied later to a floppy disk or other device, or
mounted through a loop device.
.IP "\fB\-D\fP \fIDRIVE-NUMBER\fP" 4
Specify the BIOS drive number to be stored in the FAT boot sector.
For hard disks and removable medias it is usually 0x80\(en0xFF (0x80 is first
hard disk C:, 0x81 is second hard disk D:, ...), for floppy devices or
partitions to be used for floppy emulation it is 0x00\(en0x7F (0x00 is first
floppy A:, 0x01 is second floppy B:).
.IP "\fB\-f\fP \fINUMBER-OF-FATS\fP" 4
Specify the number of file allocation tables in the filesystem.
The default is 2.
.IP "\fB\-F\fP \fIFAT-SIZE\fP" 4
Specifies the type of file allocation tables used (12, 16 or 32 bit).
If nothing is specified, \fBmkfs.fat\fP will automatically select between 12, 16
and 32 bit, whatever fits better for the filesystem size.
.IP "\fB\-g\fP \fIHEADS\fP/\fISECTORS-PER-TRACK\fP" 4
Specify \fIHEADS\fP and \fISECTORS-PER-TRACK\fP numbers which represents
disk geometry of \fIDEVICE\fP.
Both numbers are stored into the FAT boot sector.
Number \fISECTORS-PER-TRACK\fP is used also for aligning the total count of FAT
sectors.
By default disk geometry is read from \fIDEVICE\fP itself.
If it is not available then \fILBA-Assist Translation\fP and translation table
from the \fISD Card Part 2 File System Specification\fP based on total number
of disk sectors is used.
.IP "\fB\-h\fP \fINUMBER-OF-HIDDEN-SECTORS\fP" 4
Specify the number of so-called \fIhidden sectors\fP, as stored in the FAT boot
sector: this number represents the beginning sector of the partition containing
the file system.
Normally this is an offset (in sectors) relative to the start of the disk,
although for MBR logical volumes contained in an extended partition of type 0x05
(a non-LBA extended partition), a quirk in the MS-DOS implementation of FAT
requires it to be relative to the partition's immediate containing Extended Boot
Record.
Boot code and other software handling FAT volumes may also rely on this field
being set up correctly; most modern FAT implementations will ignore it.
By default, if the \fIDEVICE\fP is a partition block device, \fBmkfs.fat\fP uses
the partition offset relative to disk start.
Otherwise, \fBmkfs.fat\fP assumes zero.
Use this option to override this behaviour.
.IP "\fB\-i\fP \fIVOLUME-ID\fP" 4
Sets the volume ID of the newly created filesystem; \fIVOLUME-ID\fP is a 32-bit
hexadecimal number (for example, 2e24ec82).
The default is a number which depends on the filesystem creation time.
.IP "\fB\-I\fP" 4
Ignore and disable safety checks.
By default \fBmkfs.fat\fP refuses to create a filesystem on a device with
partitions or virtual mapping.
\fBmkfs.fat\fP will complain and tell you that it refuses to work.
This is different when using MO disks.
One doesn't always need partitions on MO disks.
The filesystem can go directly to the whole disk.
Under other OSes this is known as the \fIsuperfloppy\fP format.
This switch will force \fBmkfs.fat\fP to work properly.
.IP "\fB\-l\fP \fIFILENAME\fP" 4
Read the bad blocks list from \fIFILENAME\fP.
.IP "\fB\-m\fP \fIMESSAGE-FILE\fP" 4
Sets the message the user receives on attempts to boot this filesystem without
having properly installed an operating system.
The message file must not exceed 418 bytes once line feeds have been converted
to carriage return-line feed combinations, and tabs have been expanded.
If the filename is a hyphen (-), the text is taken from standard input.
.IP "\fB\-M\fP \fIFAT-MEDIA-TYPE\fP" 4
Specify the media type to be stored in the FAT boot sector.
This value is usually 0xF8 for hard disks and is 0xF0 or a value from 0xF9 to
0xFF for floppies or partitions to be used for floppy emulation.
.IP "\fB\-\-mbr\fP[=\fIy\fP|\fIyes\fP|\fIn\fP|\fIno\fP|\fIa\fP|\fIauto\fP]" 4
Fill (fake) MBR table with disk signature one partition which starts at sector
0 (includes MBR itself) and spans whole disk device.
It is needed only for non-removable disks used on Microsoft Windows systems and
only when formatting whole unpartitioned disk.
Location of the disk signature and partition table overlaps with the end of the
first FAT sector (boot code location), therefore there is no additional space
usage.
Default is \fIauto\fP mode in which \fBmkfs.fat\fP put MBR table only for
non-removable disks when formatting whole unpartitioned disk.
.IP "\fB\-n\fP \fIVOLUME-NAME\fP" 4
Sets the volume name (label) of the filesystem.
The volume name can be up to 11 characters long.
Supplying an empty string, a string consisting only of white space or the
string "NO NAME" as \fIVOLUME-NAME\fP has the same effect as not giving the
\fB\-n\fP option.
The default is no label.
.IP "\fB\-\-codepage\fP=\fIPAGE\fP" 4
Use DOS codepage \fIPAGE\fP to encode label.
By default codepage 850 is used.
.IP "\fB\-r\fP \fIROOT-DIR-ENTRIES\fP" 4
Select the minimal number of entries available in the root directory.
The default is 112 or 224 for floppies and 512 for hard disks.
Note that this is minimal number and it may be increased by \fBmkfs.fat\fP
due to alignment of structures.
See also \fBmkfs.fat\fP option \fB\-a\fP.
.IP "\fB\-R\fP \fINUMBER-OF-RESERVED-SECTORS\fP" 4
Select the minimal number of reserved sectors.
With FAT32 format at least 2 reserved sectors are needed, the default is 32.
Otherwise the default is 1 (only the boot sector).
Note that this is minimal number and it may be increased by \fBmkfs.fat\fP
due to alignment of structures.
See also \fBmkfs.fat\fP option \fB\-a\fP.
.IP "\fB\-s\fP \fISECTORS-PER-CLUSTER\fP" 4
Specify the number of disk sectors per cluster.
Must be a power of 2, i.e. 1, 2, 4, 8, ... 128.
.IP "\fB\-S\fP \fILOGICAL-SECTOR-SIZE\fP" 4
Specify the number of bytes per logical sector.
Must be a power of 2 and greater than or equal to 512, i.e. 512, 1024, 2048,
4096, 8192, 16384, or 32768.
Values larger than 4096 are not conforming to the FAT file system specification
and may not work everywhere.
.IP "\fB\-v\fP" 4
Verbose execution.
.IP "\fB\-\-offset\fP \fISECTOR\fP" 4
Write the filesystem at a specific sector into the device file.
This is useful for creating a filesystem in a partitioned disk image without
having to set up a loop device.
.IP "\fB\-\-variant\fP \fITYPE\fP" 4
Create a filesystem of variant \fITYPE\fP.
Acceptable values are \fIstandard\fP and \fIatari\fP (in any combination of
upper/lower case).
See above under DESCRIPTION for the differences.
.IP "\fB\-\-help\fP" 4
Display option summary and exit.
.IP "\fB\-\-invariant\fP" 4
Use constants for normally randomly generated or time based data such as
volume ID and creation time.
Multiple runs of \fBmkfs.fat\fP on the same device create identical results
with this option.
Its main purpose is testing \fBmkfs.fat\fP.
.\" ----------------------------------------------------------------------------
.SH BUGS
\fBmkfs.fat\fP can not create boot-able filesystems.
This isn't as easy as you might think at first glance for various reasons and
has been discussed a lot already.
\fBmkfs.fat\fP simply will not support it ;)
.\" ----------------------------------------------------------------------------
.SH SEE ALSO
.BR fatlabel (8),
.BR fsck.fat (8)
.\" ----------------------------------------------------------------------------
.SH HOMEPAGE
The home for the \fBdosfstools\fP project is its
.UR https://github.com/dosfstools/dosfstools
GitHub project page
.UE .
.\" ----------------------------------------------------------------------------
.SH AUTHORS
\fBdosfstools\fP were written by
.MT werner.almesberger@\:lrc.di.epfl.ch
Werner Almesberger
.ME ,
.MT Roman.Hodek@\:informatik.\:uni-erlangen.de
Roman Hodek
.ME ,
and others.
Current maintainers are
.MT aeb@\:debian.org
Andreas Bombe
.ME
and
.MT pali.rohar@\:gmail.com
Pali Rohár
.ME .
